/* button_blinker
 * Ha az A1 bemenetre kötött nyomógombot megnyomjuk, 
 * akkor a D10 kimentre kötött LED villog.
 * A nyomógomb elenegdésekor a LED alaphelyzetbe kerül.
 */
#define PUSH2    A1                   // a nyomógomb bemenet sorszáma
#define RED_LED  10                   // a piros LED kimenet sorszáma
boolean ledState = LOW, buttonState;  // állapotjelzők tárolói

void setup() {
  pinMode(RED_LED, OUTPUT);           // RED_LED legyen kimenet
  pinMode(PUSH2, INPUT_PULLUP);       // PUSH2 bemenet, belső felhúzással
}

void loop() {
  buttonState = digitalRead(PUSH2);   // Nyomógomb állapot beolvasása
  if (buttonState == LOW) {           // Ha a gomb le van nyomva
    ledState = !ledState;             // LED állapot átbillentése
  } else {                            // Különben (ha a gomb nincs lenyomva)
    ledState = LOW;                   // LED kikapcsolása
  }
  digitalWrite(RED_LED, ledState);    // LED állapot megjelenítése
  delay(100);                         // Várunk 100 ms-ot
}
