/* gombvezerelt_ledek
 * Két LED-et villogtatunk (D10 és D11 lábon) eltérő frekvenciával. 
 * A villogás gyakoriságát az A1 bemenetre kötött nyomógombbal 
 * 4 fokozatban kapcsolgathatjuk: minden gombnyomásra feleződnek az
 * átkapcsolási idők (pl. RED_LED 1000, 500, 250, 125 ms).
 * Az utolsó fokozat utáni gombnyomásra visszaugrik az
 * eredeti időzítésekre.
 * 
 * Pergésmentesítés céljából csak 20 ms-onként vizsgáljuk a
 * nyomógomb állapotát.
 */
#define RED_LED 10
#define GREEN_LED 11
#define PUSH2 A1
unsigned long nowTime, redTime, greenTime, buttonTime;
unsigned long redInterval = 1000, greenInterval = 5000;
boolean rState = HIGH, gState = HIGH, bState = HIGH;

void setup() {
  pinMode(RED_LED, OUTPUT);
  pinMode(GREEN_LED, OUTPUT);
  pinMode(PUSH2, INPUT_PULLUP);
  nowTime = millis();
  redTime = nowTime + redInterval;
  greenTime = nowTime + greenInterval;
  buttonTime = nowTime + 20;
}

void loop() {
  nowTime = millis();
  if (nowTime > redTime) {
    rState = !rState;
    digitalWrite(RED_LED, rState);
    redTime = nowTime + redInterval;
  }
  if (nowTime > greenTime) {
    gState = !gState;
    digitalWrite(GREEN_LED, gState);
    greenTime = nowTime + greenInterval;
  }
  if (nowTime > buttonTime) {
    buttonTime = nowTime + 20;
    if (digitalRead(PUSH2) != bState) {
      bState = !bState;
      if (bState == LOW) changeSpeed();
    }
  }
}

void changeSpeed() {
  if (redInterval < 200) {
    greenInterval = 5000;
    redInterval = 1000;
  }
  else {
    greenInterval /= 2;
    redInterval /= 2;
  }
}
